<?php
namespace Importacao\Logic\Integracao\Mastermaq\Classes;

use \Importacao\Logic\Integracao\Mastermaq\Classes\Migracao;

use \Importacao\Logic\Integracao\Mastermaq\Classes\Entities\MovimentoFinanceiro;

/**
 * Description of geraOcupacao
 *
 * @author matheussilva
 */
class GeraMovimentoFinanceiro extends Migracao{
    function __construct($path) {
        parent::__construct($path);
        $this->file_name = 'MovimentoFinanceiro';
        $this->setColumns();
    }

    public function createInfo($info) {
        // echo "<pre>";
        // print_r($info);
        foreach ($info as $reg){
            if($reg['SUBMOV'] != 'S'){
                $mov = new MovimentoFinanceiro();

                if(isset($reg['GOZO'])){
                    $mov->setTp_movimento($reg['SUBMOV'], 'FERI3');
                }else{
                    $mov->setTp_movimento($reg['SUBMOV']);
                }

                $mov->setNr_vinculo($reg['FUNCC']);
                $mov->setNr_evento($reg['EVENTO']);
                if ($reg['VENCS'] != '0' and $reg['VENCS'] != '' and $reg['VENCS'] != null)
                {
                    $mov->setValor($reg['VENCS']);
                } else {
                    $mov->setValor($reg['DESCS']);    
                } 
                
                $mov->setData_de_competencia('01/01/2000');
                // $mov->setDescricao_do_calculo($reg['']);
                $mov->setData_de_ocorrencia($reg['MOVIMENTO']);
                $mov->setValor_de_referencia($reg['REFERENCIA']);
                $this->objects[] = $mov;
            }
        }
    }
    public function setColumns() {
        $this->columns[] = 'Tp Movimento';
        $this->columns[] = 'Nr. Vínculo';
        $this->columns[] = 'Nr. Evento';
        $this->columns[] = 'Valor';
        $this->columns[] = 'Data de Competência';
        $this->columns[] = 'Descrição do Cálculo';
        $this->columns[] = 'Data de Ocorrência';
        $this->columns[] = 'Valor de Referência';
    }
}

