<?php
namespace Suprimentos\Repositories;

/**
 *
 */
class Encargoaf extends \Doctrine\ORM\EntityRepository
{
    /**
     * Retorna o valor total (modular) dos encargos de uma AF, agrupados pelo codigo do encargo.
     *
     * @param $cdfildest
     * @param $cdfillanc
     * @param $nrautoforn
     * @param $nrorg
     * @return array
     */
    public function getValorTotalEncargoAF($cdfildest, $cdfillanc, $nrautoforn, $nrorg)
    {
        $sql = "
          SELECT SUM(VRENCARGOAF) VALOR_ENCARGO, CDENCARGO
            FROM ENCARGOAF
            WHERE CDFILDEST  = :CDFILDEST
              AND CDFILLANC  = :CDFILLANC
              AND NRAUTOFORN = :NRAUTOFORN
              AND NRORG      = :NRORG
            GROUP BY CDENCARGO
        ";

        $params = array(
            "CDFILDEST"  => $cdfildest,
            "CDFILLANC"  => $cdfillanc,
            "NRAUTOFORN" => $nrautoforn,
            "NRORG"      => $nrorg,
        );
        try {
            return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getEncargoAF($cdfildest, $cdfillanc, $nrautoforn,$dtprogentaf, $nrorg)
    {
        $sql = "
          SELECT EA.CDENCARGO,
                  E.NMENCARGO,
                  EA.VRENCARGOAF AS VRITEMENCA,
                  EA.NRAUTOFORN,
                  EA.CDFILDEST,
                  EA.CDFILLANC
                FROM ENCARGOAF EA,
                  ENCARGO E
                WHERE EA.NRORG    = E.NRORG
                AND EA.CDENCARGO  = E.CDENCARGO
                AND EA.NRAUTOFORN = :P_NRAUTOFORN
                AND EA.CDFILDEST  = :P_CDFILDEST
                AND EA.CDFILLANC  = :P_CDFILLANC
                AND EA.DTENTRENCAF = :P_DTENTRENCAF
                AND EA.NRORG      = :P_NRORG
                ORDER BY EA.CDENCARGO
        ";

        $params = array(
            "P_CDFILDEST"  => $cdfildest,
            "P_CDFILLANC"  => $cdfillanc,
            "P_NRAUTOFORN" => $nrautoforn,
            "P_DTENTRENCAF"=> $dtprogentaf,
            "P_NRORG"      => $nrorg,
        );
        try {
            return $this->getEntityManager()->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}